#ifndef BMSBEL_BMS_H_
#define BMSBEL_BMS_H_

#include "bms_define.h"
#include "bms_word.h"
#include "bms_header_table.h"
#include "bms_regist_array.h"
#include "bms_channel.h"
#include "bms_bar.h"

// -- BmsBms -------------------------------------------------------------
class BmsBms {
public:
  explicit BmsBms( void );
  ~BmsBms();

  BmsHeaderTable& GetHeaders( void );
  BmsRegistArray& GetWavArray( void );
  BmsRegistArray& GetBmpArray( void );
  BmsRegistArray& GetBpmArray( void );
  BmsRegistArray& GetStopArray( void );

  BmsChannelManager& GetChannelManager( void );
  BmsBarManager&     GetBarManager( void );

  // IuWF݂ő̏ߐ擾
  int GetObjectExistsMaxBarPosition( void ) const;

  void MultiplyBarDivisionCount( unsigned int multiplier );

  void Merge( const BmsBms& other );

  std::string ToString( void ) const;

private:
  BmsHeaderTable    headers_;
  BmsRegistArray    wav_array_;
  BmsRegistArray    bmp_array_;
  BmsRegistArray    bpm_array_;
  BmsRegistArray    stop_array_;
  BmsChannelManager channel_manager_;
  BmsBarManager     bar_manager_;
};

#endif // BMSBEL_BMS_H_
