#include "bms_handler.h"

#include "bms_define.h"


// -- DuplicateHeader ----------------------------------------------------
BmsHandler::DuplicateHeader
BmsHandler::DuplicateHeader::DefaultObject;



BmsHandler::DuplicateHeader::DuplicateHeader( void )
{
}

BmsHandler::DuplicateHeader::~DuplicateHeader()
{
}

std::string
BmsHandler::DuplicateHeader::Handle( const std::string header,
                                     const std::string before,
                                     const std::string present )
{
  NOT_USE_VAR( header );
  NOT_USE_VAR( before );
  NOT_USE_VAR( present );
  throw DuplicateHeader::Error();
}


// -- DuplicateBarChange -------------------------------------------------
BmsHandler::DuplicateBarChange
BmsHandler::DuplicateBarChange::DefaultObject;



BmsHandler::DuplicateBarChange::DuplicateBarChange( void )
{
}

BmsHandler::DuplicateBarChange::~DuplicateBarChange()
{
}

double
BmsHandler::DuplicateBarChange::Handle( unsigned int bar,
                                        double       before,
                                        double       present )
{
  NOT_USE_VAR( bar );
  NOT_USE_VAR( before );
  NOT_USE_VAR( present );
  throw DuplicateBarChange::Error();
}


// -- ParseErrorIgnore ---------------------------------------------------
BmsHandler::ParseErrorIgnore
BmsHandler::ParseErrorIgnore::DefaultObject;

BmsHandler::ParseErrorIgnore::ParseErrorIgnore( void )
{
}

BmsHandler::ParseErrorIgnore::~ParseErrorIgnore()
{
}

bool
BmsHandler::ParseErrorIgnore::Handle( BmsParseException& e, const std::string& line )
{
  NOT_USE_VAR( e );
  NOT_USE_VAR( line );
  return false;
}


// -- GenerateRandom -----------------------------------------------------
BmsHandler::GenerateRandom::~GenerateRandom( void )
{
}


// -- GenerateRandomDefault ----------------------------------------------
BmsHandler::GenerateRandomDefault
BmsHandler::GenerateRandomDefault::DefaultObject;

BmsHandler::GenerateRandomDefault::GenerateRandomDefault( void ) :
value_( static_cast<unsigned int>( time( NULL ) ) )
{
}

BmsHandler::GenerateRandomDefault::GenerateRandomDefault( unsigned int seed ) :
value_( seed )
{
}

unsigned int
BmsHandler::GenerateRandomDefault::Generate( unsigned int max )
{
  value_ = value_ * 22695477 + 1;
  return ((( value_ >> 16 ) & 32767) % max) + 1; 
}


// -- GenerateRandomConstant ---------------------------------------------
BmsHandler::GenerateRandomConstant::GenerateRandomConstant( unsigned int constant ) :
constant_( constant )
{
}

unsigned int
BmsHandler::GenerateRandomConstant::Generate( unsigned int max )
{
  if ( max < constant_ ) {
    return 0;
  }
  return constant_;
}
