#include <errno.h>

#include "bms_define.h"
#include "bms_exception.h"

#include "bms_text_file_reader.h"


BmsTextFileReader::BmsTextFileReader( const std::string& filename ) :
filename_( filename ),
file_( fopen( filename.c_str(), "r" ) )
{
  if ( file_ == NULL ) {
    throw BmsFileOpenException( filename, errno );
  }
}

BmsTextFileReader::~BmsTextFileReader()
{
  fclose( file_ );
}

bool
BmsTextFileReader::ReadLine( std::string& buffer, bool chomp )
{
  buffer.clear();
  for (;;) {
    int c;
    c = fgetc( file_ );
    if ( c == EOF ) {
      if ( ferror( file_ ) ) {
        throw BmsFileAccessException( filename_, errno );
      }
      return NOT( buffer.empty() );
    }
    if ( c == '\n' ) {
      if ( !chomp ) {
        buffer.append( 1, '\n' );
      }
      return true;
    }
    buffer.append( 1, static_cast<char>( c ) );
  }
}
