#ifndef BMSBEL_WORD_H_
#define BMSBEL_WORD_H_

#include <string>

// -- BmsWord ------------------------------------------------------------
class BmsWord {
public:
  static const BmsWord MIN;
  static const BmsWord MAX;

  static bool CheckConstruction( const char* str );
  static bool CheckConstruction( const std::string& str );

public:
  explicit BmsWord( int value );
  explicit BmsWord( char msb, char lsb );
  explicit BmsWord( const char* str );
  explicit BmsWord( const std::string& str );

  explicit BmsWord( const BmsWord &obj );

  ~BmsWord();

  void SetByWord( BmsWord word );
  void SetByInteger( int value );
  void SetByChar( char msb, char lsb );

  int ToInteger( void ) const;
  char GetMsb( void ) const;
  char GetLsb( void ) const;
  const char* ToCharPtr( void ) const;
  std::string ToString( void ) const;

  void CheckValid( void ) const;

  void operator ++( void );
  void operator ++( int );
  void operator --( void );
  void operator --( int );

  bool equal( BmsWord obj ) const;
  bool operator ==( BmsWord obj ) const;
  bool operator !=( BmsWord obj ) const;

  int compare( BmsWord obj ) const;
  bool operator <=( BmsWord obj ) const;
  bool operator <( BmsWord obj ) const;
  bool operator >=( BmsWord obj ) const;
  bool operator >( BmsWord obj ) const;

private:
  int value_;
};

#endif // BMSBEL_WORD_H_
